#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/file.h>

#include <arc/types.h>
#include <arc/errno.h>
#include <arc/pathname.h>

int open(const char *pathname, int flags, ...)
{
    OPEN_MODE arcmode;
    _STATUS st;
    ULONG fd;

    switch(flags) {
        case O_RDONLY: arcmode = OpenReadOnly; break;
        case O_WRONLY: arcmode = OpenWriteOnly; break;
        case O_RDWR:   arcmode = OpenReadWrite; break;
        default:
            errno = EINVAL;
            return -1;
        }
    st = Open(pathname, arcmode, &fd);
    if(st != ESUCCESS) {
        errno = st;
        return -1;
        }
    return fd;
}
